# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1
# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/jboss/jbossts14/4.2.3.SP5-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

# If you want JTS support to be built,
# issue the following: 'rpmbuild --with jts'

%define with_jts %{?_with_jts:1}%{!?_with_jts:0}
%define without_jts %{!?_with_jts:1}%{?_with_jts:0}

# If you want WS support to be built,
# issue the following: 'rpmbuild --with ws'

%define with_ws %{?_with_ws:1}%{!?_with_ws:0}
%define without_ws %{!?_with_ws:1}%{?_with_ws:0}

Summary:	JBoss Transaction Service
URL:		http://labs.jboss.com/jbosstm/
# svn export https://svn.jboss.org/repos/labs/labs/jbosstm/tags/JBOSSTS_4_2_3_SP5
# tar czf jbossts-4.2.3.SP5-src.tar.gz JBOSSTS_4_2_3_SP5
Source0:	jbossts-4.2.3.SP5-src.tar.gz
Patch0:		jbossts-build.patch
Patch1:		jbossts-jfreechart.patch
Patch2:		jbossts-beamainthread.patch
Source1:	jbossts-component-info.xml

Name:		jbossts
Version:	4.2.3
Release:	1.SP5.1jpp.ep1.1%{?dist}
Epoch:		0
License:	LGPL
Group:		Development/Java
BuildArch:	noarch

BuildRequires:	jpackage-utils >= 0:1.6
BuildRequires:	ant >= 0:1.6
BuildRequires:	ant-nodeps
BuildRequires:	ant-junit
BuildRequires:	ant-trax
BuildRequires:	junit
BuildRequires:	jbossas
BuildRequires:	mx4j
BuildRequires:	jfreechart
BuildRequires:	jcommon
BuildRequires:	jta
BuildRequires:	jakarta-commons-logging
BuildRequires:	tanukiwrapper
BuildRequires:	j2ee-connector
BuildRequires:	concurrent
BuildRequires:	log4j
BuildRequires:	xerces-j2
%if %{with_jts}
BuildRequires:	antlr
BuildRequires:	avalon-logkit
BuildRequires:	avalon-framework
BuildRequires:	jacorb
BuildRequires:	picocontainer
%endif
%if %{with_ws}
BuildRequires:	stax-api
BuildRequires:	servletapi5
BuildRequires:	saaj
BuildRequires:	jaxrpc
BuildRequires:	wstx
%endif

Requires:	jpackage-utils >= 0:1.6

BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-buildroot

%description
Reliable Java and Web Services transaction management.
Includes Arjuna Transaction Service Suite (ArjunaTS) and
Arjuna's Web Services Transaction implementation, the market's only
implementation supporting both leading web services specifications
Web Services Transaction (WS-TX) and Web Services Composite Application
Framework (WS-CAF)

%if %{with_repolib}
%package	 repolib
Summary:	 Artifacts to be uploaded to a repository library
Group:	Development/Libraries/Java

%description	 repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}

%prep
%setup -q -n JBOSSTS_4_2_3_SP5
chmod -R go=u-w *

# Specify target 1.4 for all compilations
perl -p -i -e 's/<javac/<javac source="1.4" target="1.4"/' `find . -name '*build*.xml' -print`

# FIXME remove classes12.jar which is Oracle's proprietary
# FIXME Where do we get this Arjuna's TestingFramework.jar ?
# FIXME Upgrade jfreechart used by JBossTS
find . -name "*.jar" \
       -not -name "classes12.jar" \
       -not -name "TestingFramework.jar" \
       -not -name "jfreechart-0.9.15.jar" \
       -exec rm {} \;

pushd ext
build-jar-repository . jmxri
build-jar-repository . jndi
build-jar-repository . jta
build-jar-repository . jdbc-stdext
build-jar-repository . commons-logging
build-jar-repository . tanukiwrapper
build-jar-repository . j2ee-connector
build-jar-repository . concurrent
build-jar-repository . log4j
# FIXME the ones below were supposed to be under ArjunaCore/tsmx/lib/ext but
# there they are not found, so moved them here
build-jar-repository . jcommon
# FIXME Upgrade jfreechart used by JBossTS
#build-jar-repository . jfreechart
popd
pushd antbuildsystem/lib/ext
build-jar-repository . xerces-j2
popd
pushd common/lib/ext
build-jar-repository . xerces-j2
build-jar-repository . commons-logging
build-jar-repository . log4j
popd
#pushd ArjunaCore/tsmx/lib/ext
#build-jar-repository . jcommon
#build-jar-repository . jfreechart
#popd

%if %{with_jts}
pushd ArjunaJTS/jacorb/lib
build-jar-repository . tanukiwrapper
build-jar-repository . antlr
build-jar-repository . avalon-framework
build-jar-repository . avalon-logkit
build-jar-repository . jacorb
build-jar-repository . concurrent
build-jar-repository . picocontainer
popd
%endif

%patch0 -p0
#%patch1 -p0
%patch2 -p0


tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE1}

%build
export JBOSS_HOME=/usr/share/jbossas

ant -Dant.library.dir=%{_javadir} \
	-Djavac.debug=true \
	jbossjta
%if %{with_jts}
ant -Dant.library.dir=%{_javadir} \
	-f build-test.xml \
	-Djavac.debug=true \
	jbossjts
%endif

%install
rm -rf $RPM_BUILD_ROOT

# jar
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 0755 $RPM_BUILD_ROOT%{_javadir}/%{name}/resources
install -p -m 0644 install/etc/jbossjta-properties.xml $RPM_BUILD_ROOT%{_javadir}/%{name}/resources
install -p -m 0644 install/lib/jbossjta.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjta-%{version}.jar
install -p -m 0644 install/lib/jbossjta-integration.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/jbossjta-integration-%{version}.jar
install -p -m 0644 install/lib/ext/%{name}-common.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{name}-common-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr install/htdocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink


%if %{with_repolib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}
	install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
	install -d -m 755 $RPM_BUILD_ROOT%{repodir}/resources
	install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodir}/component-info.xml
	install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{PATCH0} $RPM_BUILD_ROOT%{repodirsrc}
	install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
	cp $RPM_BUILD_ROOT%{_javadir}/jbossts/jbossts-common.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jbossts/jbossjta-integration.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jbossts/jbossjta.jar $RPM_BUILD_ROOT%{repodirlib}
	cp $RPM_BUILD_ROOT%{_javadir}/jbossts/resources/jbossjta-properties.xml $RPM_BUILD_ROOT%{repodir}/resources
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -sf %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%files
%defattr(-,root,root,-)
%{_javadir}/%{name}/*

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

%changelog
* Fri Jul 27 2007 Fernando Nasser <fnasser@redhat.com> - 0:4.2.3-1.SP5.1jpp.ep1.1
- Use new release format for post-releases
- Rebuild with target = 1.4

* Sat Jul 14 2007 Fernando Nasser <fnasser@redhat.com> - 0:4.2.3.5-1jpp.ep1.2
- Rebuild

* Tue Jun 19 2007 Fernando Nasser <fnasser@redhat.com> - 0:4.2.3.5-1jpp.ep1.1
- Add repolib subpackage

* Tue Jun 19 2007 Fernando Nasser <fnasser@redhat.com> - 0:4.2.3.5-1jpp
- First JPP release

